package discRack.actions;

import discRack.*;
import discRack.presentation.*;
import discRack.business.person.PersonFactory;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * Class that realizes <B>login</B> action.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class Login extends ActionBase {

   public Login (DiscRack discRack) {
      super(discRack);
   }

   public void actionPerformed(ActionEvent e) {
      discRack.presentation.Login l=new discRack.presentation.Login();
      DElementDialog loginD=new DElementDialog(discRack.getFrame(),"DiscRack - Login");
      loginD.editDElement(l.getPanel(),true);
      if (!loginD.isCanceled()) {
         discRack.business.person.Person p=null;
         try {
            p=PersonFactory.findPerson(l.get("Login").toString());
         } catch (Exception ex) {}
         Discs dscs=new Discs(p);
         discRack.setCentralPanel(dscs.getPanel());
         discRack.getAction("Login").setEnabled(false);
         discRack.getAction("Logout").setEnabled(true);
         discRack.getAction("Register").setEnabled(false);
         try {
            discRack.setTitleUser(p.getFirstname()+" "+p.getLastname());
         } catch (Exception ex) {}
      }
   }
}
