package allinone;

import java.sql.*;

public class MakeDB {
   public static void main(String[]argv) throws Throwable {
      Class.forName("org.hsqldb.jdbcDriver");
      Connection conn = DriverManager
	 .getConnection("jdbc:hsqldb:allinoneDB","sa","");
      Statement stmt = conn.createStatement();
      stmt.execute("create table TableDCC (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftod DECIMAL (19,0) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableNDCC (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftod DECIMAL (19,0) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableCRC (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftoa DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table personSelfRef (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , login VARCHAR (32) NOT NULL , password VARCHAR (32) NOT NULL , firstname VARCHAR (32) NOT NULL , lastname VARCHAR (32) NOT NULL , boss DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table personT (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , login VARCHAR (32) NOT NULL , password VARCHAR (32) NOT NULL , firstname VARCHAR (32) NOT NULL , lastname VARCHAR (32) NOT NULL , favouredDisc DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableDCA (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftob DECIMAL (19,0) NOT NULL , reftoc DECIMAL (19,0) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableNDCA (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftob DECIMAL (19,0) NOT NULL , reftoc DECIMAL (19,0) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableCRA (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftob DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table discT (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , title VARCHAR (32) NOT NULL , artist VARCHAR (32) NOT NULL , genre VARCHAR (32) NOT NULL , owner DECIMAL (19,0) NOT NULL , isLiked INTEGER NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableCRB (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftoc DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableNDCB (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftod DECIMAL (19,0) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableDCB (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL , reftod DECIMAL (19,0) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableDCD (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table TableNDCD (oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER , somedata VARCHAR (32) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table ObjectId (next DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table tableA2 ( oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER  NOT NULL , somedata VARCHAR (32) NOT NULL)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table tableC2 ( oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER  NOT NULL , somedata VARCHAR (32) NOT NULL , reftoa DECIMAL (19,0), reftob DECIMAL (19,0))");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("create table tableB2 ( oid DECIMAL (19,0) NOT NULL PRIMARY KEY, version INTEGER  NOT NULL , somedata VARCHAR (32) NOT NULL , reftoa DECIMAL (19,0) , reftob DECIMAL (19,0));");
      stmt.close();
      conn.commit();
      conn.close();

      conn = DriverManager
	 .getConnection("jdbc:hsqldb:allinoneDB","sa","");
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableDCC ADD CONSTRAINT FK_TableDCC_1 FOREIGN KEY (reftod) REFERENCES TableDCD (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableNDCC ADD CONSTRAINT FK_TableNDCC_1 FOREIGN KEY (reftod) REFERENCES TableNDCD (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableCRC ADD CONSTRAINT FK_TableCRC_1 FOREIGN KEY (reftoa) REFERENCES TableCRA (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE personSelfRef ADD CONSTRAINT FK_personSelfRef_1 FOREIGN KEY (boss) REFERENCES personSelfRef (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE personT ADD CONSTRAINT FK_personT_1 FOREIGN KEY (favouredDisc) REFERENCES discT (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableDCA ADD CONSTRAINT FK_TableDCA_1 FOREIGN KEY (reftob) REFERENCES TableDCB (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableDCA ADD CONSTRAINT FK_TableDCA_2 FOREIGN KEY (reftoc) REFERENCES TableDCC (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableNDCA ADD CONSTRAINT FK_TableNDCA_1 FOREIGN KEY (reftob) REFERENCES TableNDCB (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableNDCA ADD CONSTRAINT FK_TableNDCA_2 FOREIGN KEY (reftoc) REFERENCES TableNDCC (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableCRA ADD CONSTRAINT FK_TableCRA_1 FOREIGN KEY (reftob) REFERENCES TableCRB (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE discT ADD CONSTRAINT FK_discT_1 FOREIGN KEY (owner) REFERENCES personT (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableCRB ADD CONSTRAINT FK_TableCRB_1 FOREIGN KEY (reftoc) REFERENCES TableCRC (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableNDCB ADD CONSTRAINT FK_TableNDCB_1 FOREIGN KEY (reftod) REFERENCES TableNDCD (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE TableDCB ADD CONSTRAINT FK_TableDCB_1 FOREIGN KEY (reftod) REFERENCES TableDCD (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE tableC2 ADD CONSTRAINT tableC2_reftoa FOREIGN KEY (reftoa) REFERENCES tableA2 (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE tableC2 ADD CONSTRAINT tableC2_reftob FOREIGN KEY (reftob) REFERENCES tableB2 (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE tableB2 ADD CONSTRAINT tableB2_reftoa FOREIGN KEY (reftoa) REFERENCES tableA2 (oid)");
      stmt.close();
      stmt = conn.createStatement();
      stmt.execute("ALTER TABLE tableB2 ADD CONSTRAINT tableB2_reftob FOREIGN KEY (reftob) REFERENCES tableB2 (oid)");
      stmt.close();
      conn.commit();
      conn.close();
   }
}
